Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/AuthenticationFailException.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/AuthenticationFailException.java	(revision 5549)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/AuthenticationFailException.java	(revision 5549)
@@ -0,0 +1,17 @@
+/*
+ * To change this template, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package clarin.cmdi.componentregistry;
+
+/**
+ *
+ * @author olhsha
+ */
+public class AuthenticationFailException extends Exception{
+    
+    public AuthenticationFailException(String message){
+        super(message);
+    }
+    
+}
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ComponentRegistry.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ComponentRegistry.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ComponentRegistry.java	(revision 5549)
@@ -23,20 +23,28 @@
     public static final String PUBLIC_NAME = "Public Registry";
 
+    
+   
+    public Owner getRegistryOwner();  
+    public void setRegistryOwner(Owner registryOwner);     
+    
+    public RegistrySpace getRegistrySpace(); 
+    public void setRegistrySpace(RegistrySpace registrySpace); 
+    
+    public Number getGroupId(); 
+    public void setGroupId(Number groupId); 
+    
+    public Number getBaseDescriptionOwnerId(String cmdId);
+    
+    public List<Number> getItemGroups(String cmdId);
     /**
      * @return List of component descriptions ordered by name ascending
      * @throws ComponentRegistryException
      */
-    List<ComponentDescription> getComponentDescriptions() throws ComponentRegistryException;
-
-    /**
-     * @param principalName
-     * @param groupId
-     * @return List of component descriptions ordered by name ascending
-     * @throws ComponentRegistryException
-     */
-    List<ComponentDescription> getComponentDescriptionsInGroup(String principalName, String groupId) throws ComponentRegistryException;
-
-    ComponentDescription getComponentDescription(String id) throws ComponentRegistryException;
-
+    List<ComponentDescription> getComponentDescriptions() throws ComponentRegistryException, UserUnauthorizedException;
+
+   
+    ComponentDescription getComponentDescriptionAccessControlled(String id) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
+
+    
     /**
      *
@@ -44,12 +52,6 @@
      * @throws ComponentRegistryException
      */
-    List<ProfileDescription> getProfileDescriptions() throws ComponentRegistryException;
-
-    /**
-    * @param groupId
-    * @return List of profile descriptions ordered by name ascending
-    * @throws ComponentRegistryException
-    */
-   List<ProfileDescription> getProfileDescriptionsInGroup(String groupId) throws ComponentRegistryException;
+    List<ProfileDescription> getProfileDescriptions() throws ComponentRegistryException, UserUnauthorizedException;
+
 
    /**
@@ -65,12 +67,13 @@
     * @throws ComponentRegistryException
     */
-   List<ProfileDescription> getProfileDescriptionsForMetadaEditor(String groupId) throws ComponentRegistryException;
-
-   ProfileDescription getProfileDescription(String id) throws ComponentRegistryException;
-
-    CMDComponentSpec getMDProfile(String id) throws ComponentRegistryException;
+   List<ProfileDescription> getProfileDescriptionsForMetadaEditor(Number groupId) throws ComponentRegistryException, UserUnauthorizedException;
+
+   ProfileDescription getProfileDescriptionAccessControlled(String id) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
+
+    CMDComponentSpec getMDProfileAccessControled(String id) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
+
+    CMDComponentSpec getMDComponentAccessControlled(String id) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
 
     CMDComponentSpec getMDComponent(String id) throws ComponentRegistryException;
-
     /**
      *
@@ -84,5 +87,5 @@
      * @return -1 if comment could not be registered
      */
-    int registerComment(Comment comment, String userId) throws ComponentRegistryException;
+    int registerComment(Comment comment, String userId) throws ComponentRegistryException, ItemNotFoundException, UserUnauthorizedException;
 
     /**
@@ -90,5 +93,5 @@
      * @return -1 if component could not be updated
      */
-    int update(BaseDescription description, CMDComponentSpec spec, Principal principal, boolean forceUpdate);
+    int update(BaseDescription description, CMDComponentSpec spec, boolean forceUpdate)  throws UserUnauthorizedException, ItemNotFoundException;
 
     /**
@@ -97,18 +100,17 @@
      * current (private) workspace to public workspace.
      */
-    int publish(BaseDescription desc, CMDComponentSpec spec, Principal principal);
-
-    void getMDProfileAsXml(String profileId, OutputStream output) throws ComponentRegistryException;
-
-    void getMDProfileAsXsd(String profileId, OutputStream outputStream) throws ComponentRegistryException;
-
-    void getMDComponentAsXml(String componentId, OutputStream output) throws ComponentRegistryException;
-
-    void getMDComponentAsXsd(String componentId, OutputStream outputStream) throws ComponentRegistryException;
-
-    /**
-     *
-     * @param profileId
-     * @param principal
+    int publish(BaseDescription desc, CMDComponentSpec spec, Principal principal)  throws UserUnauthorizedException, ItemNotFoundException;
+
+    void getMDProfileAsXml(String profileId, OutputStream output) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
+
+    void getMDProfileAsXsd(String profileId, OutputStream outputStream) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
+
+    void getMDComponentAsXml(String componentId, OutputStream output) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
+
+    void getMDComponentAsXsd(String componentId, OutputStream outputStream) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
+
+    /**
+     *
+     * @param profileIds
      * @throws IOException
      * @throws UserUnauthorizedException
@@ -116,5 +118,5 @@
      * @throws DeleteFailedException
      */
-    void deleteMDProfile(String profileId, Principal principal) throws IOException, UserUnauthorizedException, ComponentRegistryException, DeleteFailedException;
+    void deleteMDProfile(String profileId) throws IOException, UserUnauthorizedException, ComponentRegistryException, DeleteFailedException, ItemNotFoundException;
 
     /**
@@ -130,6 +132,6 @@
      * @throws DeleteFailedException
      */
-    void deleteMDComponent(String componentId, Principal principal, boolean forceDelete) throws IOException, ComponentRegistryException, UserUnauthorizedException,
-	    DeleteFailedException;
+    void deleteMDComponent(String componentId, boolean forceDelete) throws IOException, ComponentRegistryException, UserUnauthorizedException,
+	    DeleteFailedException, ItemNotFoundException;
 
     /**
@@ -149,13 +151,5 @@
     List<ProfileDescription> getUsageInProfiles(String componentId) throws ComponentRegistryException;
 
-    /**
-     * Return true if this registry is the public registry as opposed to a
-     * registry used for the user privately.
-     * */
-    boolean isPublic();
-
-    ComponentStatus getStatus();
-
-    Owner getOwner();
+  
 
     /**
@@ -168,5 +162,5 @@
      * @return List of profile descriptions ordered by name ascending
      */
-    List<ProfileDescription> getDeletedProfileDescriptions();
+    List<ProfileDescription> getDeletedProfileDescriptions()throws ComponentRegistryException;
 
     /**
@@ -174,5 +168,5 @@
      * @return List of component descriptions ordered by name ascending
      */
-    List<ComponentDescription> getDeletedComponentDescriptions();
+    List<ComponentDescription> getDeletedComponentDescriptions() throws ComponentRegistryException;
 
     /**
@@ -182,5 +176,5 @@
      * @throws ComponentRegistryException
      */
-    List<Comment> getCommentsInProfile(String profileId, Principal principal) throws ComponentRegistryException;
+    List<Comment> getCommentsInProfile(String profileId) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
 
     /**
@@ -191,5 +185,5 @@
      * @throws ComponentRegistryException
      */
-    Comment getSpecifiedCommentInProfile(String profileId, String commentId, Principal principal) throws ComponentRegistryException;
+    Comment getSpecifiedCommentInProfile(String profileId, String commentId) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
 
     /**
@@ -199,5 +193,5 @@
      * @throws ComponentRegistryException
      */
-    List<Comment> getCommentsInComponent(String componentId, Principal principal) throws ComponentRegistryException;
+    List<Comment> getCommentsInComponent(String componentId) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
 
     /**
@@ -208,5 +202,5 @@
      * @throws ComponentRegistryException
      */
-    Comment getSpecifiedCommentInComponent(String componentId, String commentId, Principal principal) throws ComponentRegistryException;
+    Comment getSpecifiedCommentInComponent(String componentId, String commentId) throws ComponentRegistryException, UserUnauthorizedException, ItemNotFoundException;
 
     /**
@@ -219,6 +213,6 @@
      * @throws DeleteFailedException
      */
-    public void deleteComment(String commentId, Principal principal) throws IOException, ComponentRegistryException, UserUnauthorizedException,
-	    DeleteFailedException;
+    public void deleteComment(String commentId) throws IOException, ComponentRegistryException, UserUnauthorizedException,
+	    DeleteFailedException, ItemNotFoundException;
 
     /**
@@ -239,3 +233,6 @@
      */
     List<String> getAllNonDeletedComponentIds();
+    
+    Boolean isItemPublic(String id) throws ItemNotFoundException;
+    
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ComponentRegistryFactory.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ComponentRegistryFactory.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ComponentRegistryFactory.java	(revision 5549)
@@ -23,9 +23,11 @@
      * @return
      */
-    ComponentRegistry getComponentRegistry(ComponentStatus status, Owner owner, UserCredentials credentials) throws UserUnauthorizedException;
-
-    ComponentRegistry getOtherUserComponentRegistry(Principal adminPrincipal, ComponentStatus status, Owner owner);
+    ComponentRegistry getComponentRegistry(RegistrySpace space, Owner owner, UserCredentials credentials, Number groupId) throws UserUnauthorizedException;
 
     ComponentRegistry getPublicRegistry();
+    
+    ComponentRegistry getOtherUserComponentRegistry(Principal adminPrincipal, Owner owner);
+    
+    ComponentRegistry getBaseRegistry(UserCredentials credentials);
 
     RegistryUser getOrCreateUser(UserCredentials credentials);
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ComponentStatus.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ComponentStatus.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ComponentStatus.java	(revision 5549)
@@ -7,34 +7,10 @@
 public enum ComponentStatus {
 
-    /**
-     * Private mode, editable non-public
-     */
-    PRIVATE(false, true),
-    /**
-     * Development mode, editable and publicly visible
-     */
-    DEVELOPMENT(false, true),
-    /**
-     * Published mode, non-editable and publicly visible
-     */
-    PUBLISHED(true, false),
-    /**
-     * Deprecated mode, non-editable and not publicly listed
-     */
-    DEPRECATED(false, false);
-    final boolean publiclyListable;
-    final boolean editable;
-
-    private ComponentStatus(boolean publiclyListable, boolean editable) {
-	this.publiclyListable = publiclyListable;
-	this.editable = editable;
-    }
-
-    public boolean isEditable() {
-	return editable;
-    }
-
-    public boolean isPubliclyListable() {
-	return publiclyListable;
-    }
+   
+    DEVELOPMENT,
+   
+    PRIDUCTION,
+    
+    DEPRECATED;
+    
 }
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/Configuration.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/Configuration.java	(revision 5548)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/Configuration.java	(revision 5549)
@@ -74,9 +74,18 @@
     }
 
+    public boolean isAdminUser(String name) {
+	if (name != null) {
+	    return name.trim().length() > 0 // user name must be set (in case an empty entry is in admin users list)
+		    && adminUsers.contains(name);
+	}
+	return false;
+    }
+    
     public void setAdminUsers(Collection<String> adminUsers) {
 	LOG.debug("Setting adminUsers to {}", Arrays.toString(adminUsers.toArray()));
 	this.adminUsers = adminUsers;
     }
-
+    
+   
     /**
      *
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ItemNotFoundException.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ItemNotFoundException.java	(revision 5549)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/ItemNotFoundException.java	(revision 5549)
@@ -0,0 +1,17 @@
+/*
+ * To change this template, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package clarin.cmdi.componentregistry;
+
+/**
+ *
+ * @author olhsha
+ */
+public class ItemNotFoundException  extends Exception {
+
+    public ItemNotFoundException(String message) {
+	super(message);
+    }
+    
+}
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/NullIdException.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/NullIdException.java	(revision 5549)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/NullIdException.java	(revision 5549)
@@ -0,0 +1,17 @@
+/*
+ * To change this template, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package clarin.cmdi.componentregistry;
+
+/**
+ *
+ * @author olhsha
+ */
+public class NullIdException extends Exception{
+    
+    public NullIdException(String message){
+        super(message);
+    }
+    
+}
Index: /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/RegistrySpace.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/RegistrySpace.java	(revision 5549)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/main/java/clarin/cmdi/componentregistry/RegistrySpace.java	(revision 5549)
@@ -0,0 +1,21 @@
+/*
+ * To change this template, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package clarin.cmdi.componentregistry;
+
+/**
+ *
+ * @author olhsha
+ */
+public enum RegistrySpace {    
+     
+    PRIVATE,    
+    
+    PUBLISHED,
+   
+    GROUP,
+    
+    REVIEW;
+    
+}
